<?php
//##############################################################################
//## pSys - interne Klassen                                                   ##
//##############################################################################
// 12.11.2009 - Tag Manager
// 05.01.2010 - Options DB
//##############################################################################

class psys_options {
	public $opt = array();   	//Options
	/**
	 * Constructor
	 */
	function __construct(){
		$this->load();
	}
	function load() {
		global $pdb, $tab_options;
		$get = $pdb->query("Select optname, optvalue From $tab_options Order by optname");
		while( $options = $pdb->fetch($get) ) {
			$o[$options['optname']]=$options['optvalue'];
		}
		$this->opt = $o;
		//var_dump($o);
	}
	function save($optname,$optvalue){
		global $pdb, $tab_options;
		$n = $pdb->escape(strtolower(trim($optname)));   //Name
		$v = $pdb->escape(trim($optvalue));  //Value
		$pdb->query("Select * From $tab_options Where optname ='$n'");
		if ($pdb->num_rows == 0) {
			$pdb->query("Insert Into $tab_options (optname,optvalue)
			             Values ('$n','$v')");
		} else {
			$pdb->query("Update $tab_options Set optvalue = '$v' Where optname = '$n'");
		}
	}
}

class psys_tagmanager {
	//Tag Manager!!
	public $type = 'main';    //Contenttype Preset

	function  save($contentid, $contenttags, $contenttype){
		//Handler für die Content Daten. Erzeugt die Tags in der DB, stellt
		//Verbindungen her und löscht diese ggf. wieder.
		//$contentid -> ID des Content Datensatz
		//$contenttags -> Tags als String mit Leerzeichen getrennt
		//$contenttype -> Typ Schlüssel des Tags
		global $pdb, $tab_tags, $tab_taglink;
		$contenttags = trim($contenttags);
		$contenttype = trim($contenttype);
		if ($contenttype == '') {
			return FALSE;
		} else {
			$this->type = $contenttype;
			//split
			$tags = split(' ',$contenttags);
			//$querylist = "'".str_replace(' ',"','",$contenttags)."'";
			//var_dump($querylist);
			//Verbindungen aufheben
			$pdb->query("Delete from $tab_taglink Where contentid = $contentid
		             And contenttype='$contenttype'");
			//Verbindungen aufbauen
			if ($contenttags != '') {
				foreach($tags as $tag) {
					if ($dbtag = $pdb->fetch_row("Select * From $tab_tags Where tagname='$tag'")) {
						//Tag vorhanden
						$tagid = $dbtag['tagid'];
					} else {
						//Tag nicht vorhanden
						$pdb->query("Insert Into $tab_tags (tagname) Values('$tag')");
						$tagid = $pdb->insert_id;
					}
					$pdb->query("Insert Into $tab_taglink (contentid,tagid,contenttype)
				             Values($contentid,$tagid,'$contenttype')");
				}
			}
			$this->clean();
		}
	}
	function delete($contentid,$contenttype) {
		//Löscht Verlinkungen zu einem Content
		$this->type = $contenttype;
		global $pdb, $tab_tags, $tab_taglink;
		$pdb->query("Delete From $tab_taglink
		             Where contentid=$contentid and contenttype='$contenttype'");
		$this->clean();
	}
	function getlist($contentid,$contenttype) {
		//liefert die Tag Liste
		$this->type = $contenttype;
		global $pdb, $tab_tags, $tab_taglink;
		$gettags = $pdb->query("Select tagname From $tab_tags
		                     Where tagid In ( Select tagid From $tab_taglink
		                                      Where contentid=$contentid and contenttype='$contenttype')
		                     Order by tagname");
		while( $tags = $pdb->fetch($gettags) ) {
			$taglist.=$tags['tagname'].' ';
		}
		return trim($taglist);
	}
	function clean(){
		//Löscht nich benutzte Tags oder Links aus der DB
		global $pdb, $tab_tags, $tab_taglink;
		$pdb->query("Delete From $tab_tags Where tagid Not In (Select tagid From $tab_taglink)");
	}
	/**
	 * Constructor
	 */
	function __construct(){
		//nothing to do
	}
}

// Alte Template Klasse
if (!class_exists('Template')) {
    class Template {
        function Template($ptTPLFile)
        {
            global $tpldir;
            $ptTPLFile = $tpldir . $ptTPLFile;
            if (!file_exists($ptTPLFile)) {
                $this->Stop("TPL File nicht auffindbar: " . $ptTPLFile);
            }
            $this->ptTPLData = @implode('', (@file($ptTPLFile)));
            $this->ptTPLData = str_replace('"', '\"', $this->ptTPLData);
        }
        function TemplateVar($ptVarName)
        {
            return ('$' . $ptVarName . ' .= "' . $this->ptTPLData . '";');
        }
        function Stop($ptErrorMsg)
        {
            echo "<pre>PTemplate error: " . $ptErrorMsg . "</pre>";
            exit;
        }
    }
}

// SmartyCore start alt
/*
class Smarty_pSys extends Smarty {
    function Smarty_pSys()
    {
        global $pdir_cache, $purl_images, $pversion;
        $this->Smarty();
        // $this->template_dir = $pdir_cache.'/smarty/';
        $this->compile_dir = $pdir_cache . '/smartycompile/';
        // $this->config_dir = '/web/www.example.com/smarty/guestbook/configs/';
        $this->cache_dir = $pdir_cache . '/smartycache/';
        // $this->caching = true;
        $this->assign("purl_images", $purl_images);
        $this->assign("pversion", $pversion);
    }
}
*/

//##############################################################################
//## SmartyMLDB - Smarty Language DB Class                                    ##
//##############################################################################

/**
 * smarty_prefilter_pmldb()
 * Parst die Language Tags aus dem unkompilierten Template
 * @param  $tpl_source
 * @return
 */
function smarty_prefilter_pmldb($tpl_source, &$smarty)
{
    // Now replace the matched language strings with the entry in the file
    return preg_replace_callback('/##(.+?)##/', '_compile_pslang', $tpl_source);
}

/**
 * _compile_pslang
 * Called by smarty_prefilter_pmldb function it processes every language
 * identifier, and inserts the language string in its place.
 */
function _compile_pslang($key)
{
	//var_dump($key);
    return $GLOBALS['_PS_LANGUAGE_']->getTranslation($key[1]);
}

/**
 * holt einen bentigten Tag aus der DB
 * Beispiel:
 * $local = "de"
 * $tag = "PLpage"
 */
function getMLDBTag($locale,$tag)
{
	GLOBAL $tab_langdb, $pdb;
	//echo "QUERY";
	$getds = $pdb->query("Select tag,word From $tab_langdb Where locale='$locale' and tag ='$tag' ");
	if ( $pdb->num_rows == 0 ) {
		$pdb->query("Insert Into $tab_langdb (tag,locale,fromtpl) values('$tag','$locale','$_SERVER[REQUEST_URI]')");
	}
	while ( $tags = $pdb->fetch($getds)) {
		if ( trim($tags['word']) != "" ) {
			$array[$tags['tag']]=$tags['word'];
		}
	}
	return $array;
}

class smartyMLDB extends Smarty {
    var $language;
    function smartyMLDB ($locale = "")
    {
        global $pdir_cache, $purl_images, $pversion, $pset, $purl, $pdir, $user, $popt;
        $this->Smarty();
        // $this->template_dir = $pdir_cache.'/smarty/';
        $this->compile_dir = $pdir_cache . '/smartycompile/';
        // $this->config_dir = '/web/www.example.com/smarty/guestbook/configs/';
        $this->cache_dir = $pdir_cache . '/smartycache/';
        // $this->caching = true;
        $this->assign("purl_images", $purl_images);
        $this->assign("pversion", $pversion);
        $this->assign("localtag", PSL_localtag);
        $this->assign("pset", $pset);
        $this->assign("purl", $purl);
        $this->assign("pdir", $pdir);
        $this->assign_by_ref('user', $user);
    	$this->assign_by_ref('popt', $popt);
        // Multilanguage Support
        // use $smarty->language->setLocale() to change the language of your template
        // $smarty->language->loadTranslationTable() to load custom translation tables
        $this->language = new psLanguage($locale); 	//create a new language object
        $GLOBALS['_PS_LANGUAGE_'] = &$this->language;
        $this->register_prefilter("smarty_prefilter_pmldb");
    }

    function fetch($_smarty_tpl_file, $_smarty_cache_id = null, $_smarty_compile_id = null, $_smarty_display = false)
    {
        // We need to set the cache id and the compile id so a new script will be
        // compiled for each language. This makes things really fast ;-)
        $_smarty_compile_id = $this->language->getCurrentLanguage() . '-' . $_smarty_compile_id;
        //$_smarty_cache_id = $_smarty_compile_id;
        // Now call parent method
        return parent::fetch($_smarty_tpl_file, $_smarty_cache_id, $_smarty_compile_id, $_smarty_display);
    }

    /**
     * test to see if valid cache exists for this template
     *
     * @param string $tpl_file name of template file
     * @param string $cache_id
     * @param string $compile_id
     * @return string |false results of {@link _read_cache_file()}
     */
    function is_cached($tpl_file, $cache_id = null, $compile_id = null)
    {
        if (!$this->caching)
            return false;

        if (!isset($compile_id)) {
            $compile_id = $this->language->getCurrentLanguage() . '-' . $this->compile_id;
            //$cache_id = $compile_id;
        }

        return parent::is_cached($tpl_file, $cache_id, $compile_id);
    }

    function clear_cache($tpl_file, $cache_id = null, $compile_id = null, $expire_time = null)
    {
        if (!isset($compile_id)) {
            $compile_id = $this->language->getCurrentLanguage() . '-' . $this->compile_id;
            //$cache_id = $compile_id;
        }
        return parent::clear_cache($tpl_file, $cache_id, $compile_id, $expire_time);
    }
}

class psLanguage {
    var $_translationTable; 	// currently loaded translation table
    var $_supportedLanguages; 	// array of all supported languages
    var $_defaultLocale; 		// the default language
    var $_currentLocale; 		// currently set locale
    var $_currentLanguage; 		// currently loaded language
    var $_languageTable; 		// array of language to file associations
    var $_loadedTranslationTables; // array of all loaded translation tables

    function psLanguage($locale = "")
    {
        $this->_languageTable = Array(
            "de" => "deu",
            "en" => "eng",
            "en-us" => "eng",
            "en-gb" => "eng",
            "nl" => "nld",
            "zh" => "chn",
            "dk" => "dnk",
            "es" => "esp",
            "fr" => "fra",
            "it" => "ita",
            "no" => "nor",
            "pl" => "pol",
            "pt" => "prt",
            "ru" => "rus",
            "sv" => "swe",
            "tr" => "tur",
            "hu" => "hun",
            "sk" => "sk"
            ); // to be continued ...
        $this->_translationTable = Array();
        $this->_loadedTranslationTables = Array();
        foreach ($this->_languageTable as $lang)
        $this->_translationTable[$lang] = Array();

        $this->_defaultLocale = 'de';
        $this->setCurrentLocale($locale);   //Standard Language locale
    }

    function getTranslation($key)
    {
		//var_dump($key);
		$tab = getMLDBTag($this->_currentLocale,$key);
        //var_dump($tab);
        if (is_array($tab)) {
			if (isset($tab[$key])) {
            	return $tab[$key];
            }
        } else {
        	return $key;
        }
    }

    function getCurrentLanguage()
    {
        return $this->_currentLanguage;
    }

    function setCurrentLanguage($language)
    {
        $this->_currentLanguage = $language;
    }

    function getCurrentLocale()
    {
        return $this->_currentLocale;
    }

    function setCurrentLocale($locale)
    {
        $language = $this->_languageTable[$locale];
        if (empty($language)) {
            die ("LANGUAGE Error: Unsupported locale '$locale'");
        }
        $this->_currentLocale = $locale;
        return $this->setCurrentLanguage($language);
    }
}

?>