<?php
//##############################################################################
//## PSCRIPT Check 1.00 Funktionen                                            ##
//##############################################################################

if (!function_exists(phpLinkCheck)) {
function phpLinkCheck($url, $r = FALSE)
{
  /*  Purpose: Check HTTP Links
   *  Usage:   $var = phpLinkCheck(absoluteURI)
   *           $var["Status-Code"] will return the HTTP status code
   *           (e.g. 200 or 404). In case of a 3xx code (redirection)
   *           $var["Location-Status-Code"] will contain the status
   *           code of the new loaction.
   *           See print_r($var) for the complete result
   *
   *  Author:  Johannes Froemter <j-f@gmx.net>
   *  Date:    2001-04-14
   *  Version: 0.1 (currently requires PHP4)
   */

  $url = trim($url);
  if (!preg_match("=://=", $url)) $url = "http://$url";
  $url = parse_url($url);
  if (strtolower($url["scheme"]) != "http") return FALSE;

  if (!isset($url["port"])) $url["port"] = 80;
  if (!isset($url["path"])) $url["path"] = "/";

  $fp = fsockopen($url["host"], $url["port"], $errno, $errstr, 3);

  if (!$fp) return FALSE;
  else
  {
    stream_set_timeout($fp, 3);
    socket_set_blocking($fp, 0);
    $head = "";
    $httpRequest = "HEAD ". $url["path"] ." HTTP/1.1\r\n"
                  ."Host: ". $url["host"] ."\r\n"
                  ."Connection: close\r\n\r\n";
    fputs($fp, $httpRequest);
    while(!feof($fp)) $head .= fgets($fp, 1024);
    fclose($fp);

    preg_match("=^(HTTP/\d+\.\d+) (\d{3}) ([^\r\n]*)=", $head, $matches);
    $http["Status-Line"] = $matches[0];
    $http["HTTP-Version"] = $matches[1];
    $http["Status-Code"] = $matches[2];
    $http["Reason-Phrase"] = $matches[3];

    if ($r) return $http["Status-Code"];

    $rclass = array("Informational", "Success",
                    "Redirection", "Client Error",
                    "Server Error");
    $http["Response-Class"] = $rclass[$http["Status-Code"][0] - 1];

    preg_match_all("=^(.+): ([^\r\n]*)=m", $head, $matches, PREG_SET_ORDER);
    foreach($matches as $line) $http[$line[1]] = $line[2];

    if ($http["Status-Code"][0] == 3)
      $http["Location-Status-Code"] = phpLinkCheck($http["Location"], TRUE);

    return $http;
  }
}
}

if (!function_exists(isemail)) {
function isemail ($cmail) {
  $ismail = -1;
  $emails = explode(",", $cmail);
  foreach ($emails as $email) {
      if ( $isemail == 1  or $isemail = -1 ) {
          if ( !eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}$",trim($email))) {
              $ismail = 0; # Mailadresse sieht seltsam aus
          }
          else {
              $ismail=1;
          }
      }
  }
  return $ismail;
}
}

//SMS Notification
function PCSMS($nummer,$titel,$status) {
        global $pcsmsgate, $pcsmskey, $pcsmssender, $cpssms;
        $notifytext = "Check:$titel - Status:$status";
        $notify_length=strlen($notifytext);
        $notifytext = urlencode($notifytext);

    //Powersend
        if ( $pcsmsgate == "powersend" ) {
                $command = "http://web146.adminonline.de/b2b/sms.php?key=$pcsmskey&text=$notifytext&handynr=$nummer&kennung=$pcsmssender";
                $fp = @fopen($command,"r");
                @stream_set_timeout($fp, 5);
                $result = @fgets($fp);
        } // Ende Powersend

    //CPS
        if ( $pcsmsgate == "cps" ) {
            $cpstplv = "3.07";
                if ( substr($nummer,0,1) == 0 ) {
                        $nummer = "49".substr($nummer,1);
                }
                $command = "http://srs.cps-datensysteme.de/post/postservlet.cgi?action=SEND&templateversion=$cpstplv&customer_id=$cpssms[customer_id]&profile=$cpssms[profile]&password=$cpssms[password]&domain=$nummer&source_address=$pcsmssender&sms_text=$notifytext&sms_text_length=$notify_length";
                $fp = @fopen($command,"r");
                @stream_set_timeout($fp, 5);
                $result = @fgets($fp);
                //echo $result;
    } // Ende CPS
}

//IS_IP
function is_ip($str) {
	if ((substr_count($str, ".") != 3) or (empty($str))) {
		return false;
	}
	$ip_array = explode(".", $str);
	for ($i = 0; $i < count($ip_array); $i++) {
		if ( !is_numeric($ip_array[$i]) )	{
			return false;
		}
	}
	return true;
}

//Server Status Checker
function ServerStatus($hostname,$port) {
  //$hostname = Domainname oder IP oder URL
  //$port = Port zum Check
  global $pchecktimeout;

  //Wenn URL angegeben
  if ( strstr($hostname,'http://' ))  {
     $result = @file_get_contents($hostname);
     if ( strstr($result,'success') ) { $status = 'OK'; }
     else                             { $status = 'NOTOK'; }
     //echo $result;
  }
  	//Wenn Port = 0 -> PING
  	elseif ( $port == 0  ) {
  		$ip = gethostbyname($hostname);
  		if ( is_ip($ip) ) {
  			$cmd = "ping -c2 -w2 $ip";
  			//echo $cmd;
  			exec($cmd, $ping, $result);
  			if ( $result == 0 ) { $status = 'OK'; }
  			else                { $status = 'NOTOK'; }

  		} else {
  			$status = 'NOTOK';
  		}
  	}

  // Wenn Server:Port
  else {
    @$fp = fsockopen ("$hostname", $port, $errno, $errstr, 10);
    if (!$fp) { $status = 'NOTOK'; }
    else { $status = 'OK';}
    @fclose($fp);
  }
    return $status;
}

function PCStartTimer() {
  $mtime1 = microtime();
  $mtime1 = explode(" ",$mtime1);
  $mtime1 = $mtime1[1] + $mtime1[0];
  return $mtime1;
}

function PCCheckTimer($startmtime) {
  $mtime2 = microtime();
  $mtime2 = explode(" ",$mtime2);
  $mtime2 = $mtime2[1] + $mtime2[0];
  return round(($mtime2 - $startmtime),4);
}

?>